%INPUT: KERNEL data stored by the order of column in matrix market format
%OUTPUT: count the nubmer of every column, count the nonzero index of the first element of every column in the entire matrix
%           binary output format: int32(row index), int32 (colun index), double
%           (value)
%           *.info output format: colIdx, numNonzeroPerCol, globalIdxPerCol
%input parameter
inputFilename='kernel_col.mm2';
numCol=520;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%global nonzero index for every column, 0 indicates no nonzero in this
%column
globalIdxPerCol=zeros(numCol,1);
%count the global index (number of nonzero) for the first element of every
%column
globalIdxPerColCounter=0;

%count the number of nonzeros in every column,
numNonzeroPerCol=zeros(numCol,1);
numNonzeroPerColCounter=0;

%column index
colIdx=(1:1:numCol)';
colIdxCounter=1;

fid1=fopen(inputFilename, 'r');
outputFilename=sprintf('%s.bin', inputFilename);
fid2=fopen(outputFilename, 'w');


while feof(fid1) ==false
    [data1, count]=fscanf(fid1, '%d %d %e',[1 3]);
    if count~=0
        if colIdxCounter<data1(2) 
            %disp([colIdx numNonzeroPerCol globalIdxCounter]);
            if colIdxCounter~=1
                numNonzeroPerCol(colIdxCounter)=numNonzeroPerColCounter;
                globalIdxPerCol(colIdxCounter)=globalIdxPerColCounter-numNonzeroPerColCounter+1;
            end
            %%%
            numNonzeroPerColCounter=0;
            colIdxCounter=data1(2);
        end
        globalIdxPerColCounter=globalIdxPerColCounter+1;
        numNonzeroPerColCounter=numNonzeroPerColCounter+1;
        
%       write binary file
        fwrite(fid2, int32(data1(1)),'int32'); fwrite(fid2, int32(data1(2)),'int32'); fwrite(fid2, data1(3),'double');
    end
end
%deal with the last line
 numNonzeroPerCol(colIdxCounter)=numNonzeroPerColCounter;
 globalIdxPerCol(colIdxCounter)=globalIdxPerColCounter-numNonzeroPerColCounter+1;       


%printf file info ...
outputFileInfo=sprintf('%s.info', inputFilename);
fid3=fopen(outputFileInfo, 'w');
len=length(colIdx);
for i=1:len
    fprintf(fid3, '%d %d %d\n',colIdx(i), numNonzeroPerCol(i), globalIdxPerCol(i));
end

fclose(fid1);
fclose(fid2);
fclose(fid3);


%binary ...

%test .bin
